// Operation Mode
#define ADT7410_CONT    0   // Continuous (default)
#define ADT7410_ONE     1   // One shot
#define ADT7410_SPS     2   // SPS mode
#define ADT7410_OFF     3   // Shutdown

//------------------------------------------------
// Get temperature
// uint8_t addr:    I2C Address (0x48,49,4A,4B)
// float * f_data   Temperature data (float)
//------------------------------------------------
void ADT7410_get_temp(uint8_t addr, float * f_data);

//-----------------------------------------------------------------------
//  X[ũfoCXw̃f[^ǂݍޏ                       
//                                                                            
//    uint8_t addr      : I2CAhX             
//    uint8_t adrs_pt   : Ǐof[^̃WX^[AhX                  
//    uint8_t *data     : Ǐof[^̊i[                             
//    uint8_t len       : Ǐof[^̃oCg                             
//-----------------------------------------------------------------------
void ADT7410_Read(uint8_t addr, uint8_t adrs_pt, uint8_t *data, uint8_t len);

//-----------------------------------------------------------------------
//  w肵f[^̏                         
//    uint8_t addr      : I2CAhX             
//    uint8_t adrs_pt   : ރf[^̃WX^[AhX                  
//    uint8_t *data     : ݗpobt@[|C^[                             
//    uint8_t len       : ރf[^̃oCg                             
//-----------------------------------------------------------------------
void ADT7410_Write(uint8_t addr, uint8_t adrs_pt, uint8_t *data, uint8_t len);




