/**
  Section: Included Files
*/
#include "mcc_generated_files/system.h"
#include "AQM1248A_PIC.h"
#include "i2c1_PIC.h"
#include "ADT7410_PIC.h"
/*
                         Main application
 */
int main(void)
{
    float h_data[3];
    // initialize the device
    
    uint8_t d_buf[5];
    char c_buf[30];
    int a;
    
    SYSTEM_Initialize();
    InitI2C_Master();
    Init_LCD();

    while (1)
    {
        LCD_CLS(0);
        for(a = 0; a < 20; a ++) c_buf[a] = 0;
        sprintf(c_buf,"State:%X", DHT20_chk());
        LCD_Print_Str(0,0,c_buf,1);
        __delay_ms(50);
        
        DHT20_Get_Data(h_data);
        for(a = 0; a < 20; a ++) c_buf[a] = 0;
        sprintf(c_buf,"T:%0.1f'C", h_data[1]);
        LCD_Print_Str(0,10,c_buf,1);
        for(a = 0; a < 20; a ++) c_buf[a] = 0;
        sprintf(c_buf,"H:%0.1f", h_data[0]);
        c_buf[strlen(c_buf)] = '%';
        LCD_Print_Str(0,20,c_buf,1);

        __delay_ms(5000);
    }

    return 1;
}